src/Entity/ActionLog.php
<?php

namespace App\Entity;

use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;
use Ramsey\Uuid\Doctrine\UuidV7Generator;
use Ramsey\Uuid\UuidInterface;
use stdClass;

#[ORM\Entity]
#[ORM\Table(name: 'action_log')]
class ActionLog implements \Stringable
{
  #[ORM\Id]
  #[ORM\GeneratedValue(strategy: "CUSTOM")]
  #[ORM\CustomIdGenerator(class: UuidV7Generator::class)]
  #[ORM\Column(type: 'uuid', unique: true)]
  private UuidInterface $id;

  #[ORM\Column(type: Types::DATETIME_MUTABLE)]
  private \DateTimeInterface $timestamp;

  #[ORM\Column(type: Types::STRING, length: 255)]
  private string $type;

  #[ORM\Column(type: Types::STRING, length: 255)]
  private string $entityClass;

  #[ORM\Column(type: Types::INTEGER, nullable: true)]
  private ?int $entityId = null;

  #[ORM\Column(type: Types::TEXT, nullable: true)]
  private ?string $changes = null; // Détails des modifications (JSON)

  #[ORM\Column(type: Types::INTEGER, length: 255, nullable: true)]
  private ?int $userIdentifier = null;

  public static function new(
    string  $type,
    string  $entityClass,
    ?int    $entityId,
    ?string $changes,
    ?int $userIdentifier
  ): ActionLog
  {
    $log = new ActionLog();
    $log->setTimestamp(new \DateTimeImmutable());
    $log->setType($type);
    $log->setEntityClass($entityClass);
    $log->setEntityId($entityId);
    $log->setChanges($changes);
    $log->setUserIdentifier($userIdentifier);

    return $log;
  }

  public function getId(): UuidInterface
  {
    return $this->id;
  }

  public function getEntityId(): ?int
  {
    return $this->entityId;
  }

  public function setEntityId(?int $entityId): ActionLog
  {
    $this->entityId = $entityId;
    return $this;
  }

  public function getTimestamp(): \DateTimeInterface
  {
    return $this->timestamp;
  }

  public function setTimestamp(\DateTimeInterface $timestamp): ActionLog
  {
    $this->timestamp = $timestamp;
    return $this;
  }

  public function getType(): string
  {
    return $this->type;
  }

  public function setType(string $type): ActionLog
  {
    $this->type = $type;
    return $this;
  }

  public function getEntityClass(): string
  {
    return $this->entityClass;
  }

  public function setEntityClass(string $entityClass): ActionLog
  {
    $this->entityClass = $entityClass;
    return $this;
  }

  public function getChanges(): ?string
  {
    return $this->changes;
  }

  public function getChangesObject(): mixed
  {
    if (empty($this->changes)) {
      return null;
    }

    return json_decode($this->changes);
  }

  public function setChanges(?string $changes): ActionLog
  {
    $this->changes = $changes;
    return $this;
  }

  public function getUserIdentifier(): ?int
  {
    return $this->userIdentifier;
  }

  public function setUserIdentifier(?int $userIdentifier): ActionLog
  {
    $this->userIdentifier = $userIdentifier;
    return $this;
  }

  public function __toString(): string
  {
    return $this->type;
  }

  public function isConsistent(): bool
  {
    if (empty($this->changes)) {
      return false;
    }

    /** @var stdClass{'valid': bool} $changesObj */
    $changesObj = json_decode($this->changes);
    return $changesObj->valid;
  }
}

templates/bundles/EasyAdminBundle/crud/detail.html.twig
{% extends '@!EasyAdmin/crud/detail.html.twig' %}

{% block detail_fields %}
  {{ parent() }}

  {% set logs = getLogsForEntity(entity.instance) %}
  {% if logs %}
    <hr/>

    <div class="content-header-title">
      <h2 class="title">Logs</h2>
    </div>

    <table class="table">
      <thead>
      <tr>
        <th>Date</th>
        <th>Type</th>
        <th>Changement</th>
        <th>Responsable</th>
      </tr>
      </thead>
      <tbody>
      {% for log in logs %}
        <tr>
          <td>{{ log.timestamp|date('d/m/Y H:i:s') }}</td>
          <td>{{ _self.render_type(log) }}</td>
          <td>{{ _self.render_changes(log) }}</td>
          <td><a href="{{ ea_url()
              .setController('App\\Controller\\Admin\\UserCrudController')
              .setAction('detail')
              .setEntityId(log.userIdentifier) }}">{{ log.userIdentifier }}</a></td>
        </tr>
      {% endfor %}
      </tbody>
    </table>
  {% endif %}

{% endblock %}

{% macro render_changes(log) %}
  {% if not log.changesObject.data %}
    Format de données invalide
  {% else %}
    {% set data = log.changesObject.data %}
    {% if log.type is same as 'workflow_transition' %}
      Workflow "{{ data.workflow }}": transitioned from "{{ data.from }}" to "{{ data.to }}" via "{{ data.transition }}"
    {% elseif log.type is same as 'workflow_denied' %}
      Workflow "{{ data.workflow }}": try to make transition from "{{ data.from }}" to "{{ data.to }}" via "{{ data.transition }}"
    {% elseif log.type is same as 'entity_update' %}
      Champs modifiés : <span class="badge badge-secondary">{{ data.changes.fields_changed|join('</span>,<span class="badge badge-secondary">')|raw }}</span>
    {% elseif log.type is same as 'user_connected' %}
      {% if data.mode is defined %}
        <span class="badge badge-secondary">{{ "connexionmode.#{data.mode}"|trans }}</span>
      {% else %}
        -
      {% endif %}
    {% elseif log.type is same as 'user_connection_failed' %}
      Login : {{ data.login }}
    {% else %}
      <pre>{{ log.changesObject.data|json_encode }}</pre>
    {% endif %}
  {% endif %}
{% endmacro %}

{% macro render_type(log) %}

  {% if not log.isConsistent %}
    <span class="badge badge-danger">Inconsistent ({{ log.type }})</span>
  {% elseif log.type is same as 'workflow_transition' %}
    <span class="badge badge-primary">Workflow transition</span>
  {% elseif log.type is same as 'workflow_denied' %}
    <span class="badge badge-danger">Workflow transition denied</span>
  {% elseif log.type is same as 'entity_update' %}
    <span class="badge badge-info">Mise à jour</span>
  {% elseif log.type is same as 'user_connected' %}
    <span class="badge badge-success">Connexion réussie</span>
  {% elseif log.type is same as 'user_connection_failed' %}
    <span class="badge badge-danger">Connexion échouée</span>
  {% elseif log.type is same as 'entity_create' %}
    <span class="badge badge-success">Création de l'entité</span>
  {% else %}
    <span class="badge badge-secondary">{{ log.type }}</span>
  {% endif %}

{% endmacro %}